import 'reflect-metadata';
export declare class JSONTypeError extends TypeError {
}
export declare class JSONObject extends Object {
    private newValue;
    private set;
    private get;
    constructor(json?: any);
    static metadata(symbol: Symbol, value: any): (target: any, key: any) => void;
    static custom(code: (object: any, key: string, value: any) => any): (target: any, key: any) => void;
    static validate(code: (object: any, key: string, value: any) => void): (target: any, key: any) => void;
    static union<T>(values: Array<T>): (target: any, key: any) => void;
    static map(newKey: string): (target: any, key: any) => void;
    private static isOptional;
    private static jsonKeys;
    private static preprocess;
    private validateNumeric;
    static array(type: Function): (target: any, key: any) => void;
    static integer(target: any, key: string): void;
    static gt(value: number): (target: any, key: any) => void;
    static gte(value: number): (target: any, key: any) => void;
    static lt(value: number): (target: any, key: any) => void;
    static lte(value: number): (target: any, key: any) => void;
    static eq(value: any): (target: any, key: any) => void;
    static ne(value: any): (target: any, key: any) => void;
    static passthrough(target: any, key: string): void;
    static required(target: any, key: string): void;
    static optional(target: any, key?: string): void | any;
}
export declare function validate(code: (object: any, key: string, value: any) => void): (target: any, key: any) => void;
export declare function custom(code: (object: any, key: string, value: any) => any): (target: any, key: any) => void;
export declare function union<T>(values: Array<T>): (target: any, key: any) => void;
export declare function required(target: any, key: string): void;
export declare function optional(target: any, key?: string): void | any;
export declare function map(jsonKey: string): (target: any, key: any) => void;
export declare function passthrough(target: any, key: string): void;
export declare function integer(target: any, key: string): void;
export declare function gt(value: number): (target: any, key: any) => void;
export declare function gte(value: number): (target: any, key: any) => void;
export declare function lt(value: number): (target: any, key: any) => void;
export declare function lte(value: number): (target: any, key: any) => void;
export declare function eq(value: any): (target: any, key: any) => void;
export declare function ne(value: any): (target: any, key: any) => void;
export declare function array(value: any): (target: any, key: any) => void;
